<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="接入源名称" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入接入源名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item label="数据来源系统名称" prop="systemName">
        <el-input
          v-model="queryParams.systemName"
          placeholder="请输入数据来源系统名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="ip地址" prop="ip">
        <el-input
          v-model="queryParams.ip"
          placeholder="请输入ip地址"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="端口号" prop="port">
        <el-input
          v-model="queryParams.port"
          placeholder="请输入端口号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['source:source:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['source:source:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['source:source:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['source:source:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="sourceList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="接入源名称" align="center" prop="name" />
      <el-table-column label="数据来源系统名称" align="center" prop="systemName" />
      <el-table-column label="数据库类型" align="center" prop="dataType" />
      <el-table-column label="ip地址" align="center" prop="ip" />
      <el-table-column label="端口号" align="center" prop="port" />
      <el-table-column label="数据库名称" align="center" prop="databaseName" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-link"
            @click="handleConnect(scope.row)"
          >测试连接</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-connection"
            v-if="scope.row.isInit === 'Y'"
            @click="handleStructure(scope.row)"
          >同步资产结构</el-button>
            <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['source:source:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['source:source:remove']"
          >删除</el-button>

        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改数据源对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="80%" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="140px">
        <el-form-item label="接入源名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入接入源名称" />
        </el-form-item>
        <el-form-item label="数据来源系统名称" prop="systemName">
          <el-input v-model="form.systemName" placeholder="请输入数据来源系统名称" />
        </el-form-item>
        <el-form-item label="数据库类型" prop="dataType">
          <el-input v-model="form.dataType" placeholder="请输入数据库类型" />
        </el-form-item>
        <el-form-item label="ip地址" prop="ip">
          <el-input v-model="form.ip" placeholder="请输入ip地址" />
        </el-form-item>
        <el-form-item label="端口号" prop="port">
          <el-input v-model="form.port" placeholder="请输入端口号" />
        </el-form-item>
        <el-form-item label="数据库名称" prop="databaseName">
          <el-input v-model="form.databaseName" placeholder="请输入数据库名称" />
        </el-form-item>
        <el-form-item label="用户名" prop="userName">
          <el-input v-model="form.userName" placeholder="请输入用户名" />
        </el-form-item>
        <el-form-item label="密码" prop="password">
          <el-input v-model="form.password" placeholder="请输入密码" />
        </el-form-item>
        <el-form-item label="数据连接参数" prop="connectionParam">
          <el-input v-model="form.connectionParam" placeholder="请输入数据连接参数" />
        </el-form-item>
        <el-form-item label="初始化连接数量" prop="initTotal">
          <el-input v-model="form.initTotal" placeholder="请输入初始化连接数量" />
        </el-form-item>
        <el-form-item label="最大连接数量" prop="maxNum">
          <el-input v-model="form.maxNum" placeholder="请输入最大连接数量" />
        </el-form-item>
        <el-form-item label="最长等待时间" prop="maxWaitTime">
          <el-input v-model="form.maxWaitTime" placeholder="请输入最长等待时间" />
        </el-form-item>
        <el-form-item label="最大等待次数" prop="maxWaitSize">
          <el-input v-model="form.maxWaitSize" placeholder="请输入最大等待次数" />
        </el-form-item>
        <el-form-item label="驱动" prop="driverName">
          <el-input v-model="form.driverName" placeholder="请输入驱动名称" />
        </el-form-item>
        <el-form-item label="是否初始化" prop="isInit">
          <el-radio v-model="form.isInit" label="Y">是</el-radio>
          <el-radio v-model="form.isInit" label="N">否</el-radio>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入是否初始化" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listSource,
  getSource,
  delSource,
  addSource,
  updateSource,
  testConnection,
  synchronous
} from "@/api/source/source";

export default {
  name: "Source",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 数据源表格数据
      sourceList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        name: null,
        systemName: null,
        dataType: null,
        ip: null,
        port: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询数据源列表 */
    getList() {
      this.loading = true;
      listSource(this.queryParams).then(response => {
        this.sourceList = response.data.rows;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        name: null,
        systemName: null,
        dataType: null,
        ip: null,
        port: null,
        databaseName: null,
        userName: null,
        password: null,
        connectionParam: null,
        isInit: null,
        initTotal: null,
        maxNum: null,
        maxWaitTime: null,
        maxWaitSize: null,
        driverName: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 资产接入 测试连接 */
    handleConnect(dataSource) {
      testConnection(dataSource).then(res => {
        console.log(res)
        if (res.code == 200) {
          this.$message.success("连接成功")
          this.getList()
        } else {
          this.$message.error("连接失败")
        }
      })
    },
    /** 同步资产结构 */
    handleStructure(dataSource){
      synchronous(dataSource).then(res=>{
        console.log(res)
        if (res.code == 200) {
          this.$message.success("同步资产结构成功")
          this.getList()
        } else {
          this.$message.error("同步资产结构失败")
        }
      })
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加数据源";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getSource(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改数据源";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateSource(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addSource(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除数据源编号为"' + ids + '"的数据项？').then(function() {
        return delSource(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('source/source/export', {
        ...this.queryParams
      }, `source_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
